{ written by Kulverstukas in 2010.11.06 }
unit smplupxgui;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Buttons, Menus, ComCtrls, ExtCtrls, IniFiles, ShellAPI;

type

  { TForm1 }

  TForm1 = class(TForm)
    BrowseFile: TButton;
    Button1: TButton;
    SelectedFile: TEdit;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioGroup1: TRadioGroup;
    SelectUPX: TButton;
    SelectedUPX: TEdit;
    GroupBox1: TGroupBox;
    compression: TTrackBar;
    procedure BrowseFileClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure compressionChange(Sender: TObject);
    procedure FormClose(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SelectUPXClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  OpenDialog : TOpenDialog;
  IniFile : TIniFile;

implementation

{ TForm1 }
//======================================================
procedure TForm1.compressionChange(Sender: TObject);
begin
 Form1.Label1.Caption := 'Compression: '+IntToStr(compression.Position);
end;
//======================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
//=======
 OpenDialog := TOpenDialog.Create(OpenDialog);
//=======
 IniFile    := TIniFile.Create(ExtractFilePath(Application.ExeName)+'UPXGUIsettings.ini');
  try
   Form1.SelectedUPX.Text  := IniFile.ReadString('UPXGUI','UPX','');
   Form1.SelectedFile.Text := IniFile.ReadString('UPXGUI','File','');
   Form1.compression.Position := StrToInt(IniFile.ReadString('UPXGUI','Compression',IntToStr(Form1.compression.Position)));
  finally
   IniFile.Free;
  end;
//=======
 Form1.Label1.Caption := 'Compression: '+IntToStr(compression.Position);
//=======
end;
//======================================================
procedure TForm1.SelectUPXClick(Sender: TObject);
begin
//=======
  with OpenDialog do
   begin
    Filter     := 'Exe files (*.exe)|*.exe|';
    Title      := 'Select UPX packer';
   end;
//=======
  if OpenDialog.Execute = True then
   begin
    Form1.SelectedUPX.Caption := OpenDialog.FileName;
   end;
//=======
end;
//======================================================
procedure TForm1.BrowseFileClick(Sender: TObject);
begin
//=======
  with OpenDialog do
   begin
    Filter := 'Exe files (*.exe)|*.exe|';
    Title  := 'Select a file to compress/decompress';
   end;
//=======
  if OpenDialog.Execute = True then
   begin
    Form1.SelectedFile.Text := OpenDialog.FileName;
   end;
//=======
end;
//======================================================
procedure TForm1.FormClose(Sender: TObject);
begin
 IniFile := TIniFile.Create(ExtractFilePath(Application.ExeName)+'UPXGUIsettings.ini');
  try
   IniFile.WriteString('UPXGUI','UPX',Form1.SelectedUPX.Text);
   IniFile.WriteString('UPXGUI','File',Form1.SelectedFile.Text);
   IniFile.WriteString('UPXGUI','Compression',IntToStr(Form1.compression.Position));
  finally
   IniFile.Free;
  end;
end;
//======================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
 if Form1.RadioButton1.Checked = True then
  begin
   Form1.Caption := '[SMPL]UPXGUI - Compressing';
   ShellAPI.ShellExecute(Handle,'open',PChar('cmd.exe'),PChar(' /C '+Form1.SelectedUPX.Text+' -9 '+'"'+Form1.SelectedFile.Text+'"'),nil,1);
   Form1.Caption := '[SMPL]UPXGUI';
  end
 else
  begin
   Form1.Caption := '[SMPL]UPXGUI - Decompressing';
   ShellAPI.ShellExecute(Handle,'open',PChar('cmd.exe'),PChar('/C '+Form1.SelectedUPX.Text+' -d '+'"'+Form1.SelectedFile.Text+'"'),nil,1);
   Form1.Caption := '[SMPL]UPXGUI';
  end;
end;
//======================================================

initialization
  {$I smplupxgui.lrs}

end.
